Super Jumping! Jumping! Jumping! (前面那篇文章因为格式问题删了重写了一篇

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 40411    Accepted Submission(s): 18655


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 

Output
For each case, print the maximum according to rules, and one line one case.
 

Sample Input
  
  
3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
 

Sample Output
  
  
4 10 3
 

Author
lcy


解题思路


这道题目其实就是一道动态规划,我们需要求给定的,具有顺序的,子集的最大和(可以不连续)


我们可以用到动态规划的思想。以 1 2 3 4这个例子来阐述

首先,我们可以用dp数组来表示对应的以这个旗子作为终点的时候的最大和(也就是我们的最优解)

状态转移方程

if(a[j]<a[i]&&a[i]+d[j]>d[i])

d[i]=a[i]+d[j]

我们的初值就是,dp[0]=1,因为对于1来说,它前面没有别的棋子了。

对于2来说,我们考虑当它作为终点的时候,先赋值dp[i]=a[i](因为你完全可以不选择前面的,自己作为起点),有前子“1”可以选,1<2,而且1+2>2,所以dp[i]更新为3

对于3而言,也是同样的道理。

但是我觉得比较关键的是,3前面的1和2,也就是dp[0]和dp[1]都是对应的最优解!我们的整体最优解是由局部最优解来获得的!


代码展示

#include<iostream>
using namespace std;
int a[1001];
long long dp[1001];
int main()
{
	int n=0;
	while(cin>>n)
	{
		if(n==0)
		break;
		for(int i=0;i<n;i++)
		{
			cin>>a[i];
			dp[i]=0;
		}
		dp[0]=a[0];
		for(int i=1;i<n;i++)
		{
			dp[i]=a[i];
			for(int j=0;j<i;j++)
			{
				if(a[i]>a[j])
				{
					if(a[i]+dp[j]>dp[i])
					dp[i]=a[i]+dp[j];
				}
			}
		}
		long long max=dp[0];
		for(int i=1;i<n;i++)
		{
			if(max<dp[i])
			max=dp[i];
		}
		cout<<max<<endl;	
	}
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值